package EntryAssociaterWithUploadAsset::CMS;

use strict;
use Data::Dumper;

sub template_source {
    my ($cb, $app, $template) = @_;

    my $old;
    my $new;

    $old = <<HTML;
<mtapp:setting
  id="auto_rename_non_ascii"
HTML
    $old = quotemeta($old);

    $new = <<HTML;
<mtapp:setting
    id="entry_id_field"
    label_class="top-label"
    label="<__trans_section component="EntryAssociaterWithUploadAsset"><__trans phrase="AssetEntry:"></__trans_section>"
    label_class="left-label"
>
<select id="entry_id" name="entry_id" />
    <option value="0"><__trans phrase="none"></option>
  <mt:loop name="entries">
    <option value="<mt:var name="entry_id">"><mt:var name="entry_title">(ID:<mt:var name="entry_id">)</option>
  </mt:loop>
</select>
</mtapp:setting>
<mtapp:setting
  id="auto_rename_non_ascii"
HTML

    $$template =~ s/$old/$new/;

    $old = <<HTML;
  fd.append('extra_path', jQuery('#extra_path').val() );
HTML
    $old = quotemeta($old);

    $new = <<HTML;
  fd.append('extra_path', jQuery('#extra_path').val() );
  fd.append('entry_id', jQuery('#entry_id').val() );
HTML

    $$template =~ s/$old/$new/;
}

sub template_param {
    my ($cb, $app, $param, $tmpl) = @_;

    $param->{entries} = _populate_entry_loop( $app->blog );

    1;
}

sub _populate_entry_loop {
    my $blog = shift;
    my @entries = MT::Entry->load( { blog_id => $blog->id },
                                   { direction => 'descend',
                                     sort => 'created_on', } );
    @entries = sort { $b->id <=> $a->id } @entries;
    my @maps;
    my %types;
    foreach my $entry (@entries) {
        my $map = {};
        $map->{entry_id} = $entry->id;
        $map->{entry_title} = $entry->title;
        push @maps, $map;
    }
#    @maps = sort { $a->cat_id <=> $b->cat_id } @maps;
    return \@maps;
}

sub post_save {
    my ($eh, $app, $asset, $original) = @_;

    my $q = $app->param;
    if ( my $entry_id = $q->param('entry_id')) {
        require MT::Asset;
        require MT::ObjectAsset;

        my $obj_asset = MT::ObjectAsset->load(
            {   asset_id  => $asset->id,
                object_ds => 'entry',
                object_id => $entry_id
            }
        );
        unless ($obj_asset) {
            my $obj_asset = new MT::ObjectAsset;
            $obj_asset->blog_id( $app->blog->id );
            $obj_asset->asset_id( $asset->id );
            $obj_asset->object_ds('entry');
            $obj_asset->object_id( $entry_id );
            $obj_asset->save;
        }
    }
}

1;
